'-------------------------------------------------------------------------------------------

' : ATMEGA8A    "AVR"    
'  : BASCOM-AVR 2.0.7.1
' : sasha_1973

'-------------------------------------------------------------------------------------------


'---------------------------   -----------------------------------------

 $regfile = "m8def.dat"
 $crystal = 1000000
 $framesize = 32
 $hwstack = 40
 $swstack = 16
 $baud = 4800

'----------------------------   USART  --------------------------------------

'  Config Com1 = 4800 , Synchrone = 0 , Parity = None , Stopbits = 1 , Databits = 8 , Clockpol = 0
  Config Pind.0 = Input       '   RxD,  USART
  Config Pind.1 = Output       '   TxD,  USART

'---------------------------   LCD  --------------------------------------

  Config Lcdpin = Pin , Rs = Portb.0 , E = Portb.1 , Db4 = Portb.2 , Db5 = Portb.3 , Db6 = Portb.4 , Db7 = Portb.5
  Config Lcd = 20 * 4       '  LCD
  Initlcd '  LCD
  Waitms 50       '    
  Cursor Off Noblink       '   
'  Cursor On Noblink         '   
'  Cursor On Blink           '   
  Cls     '  ,   

  Dim _lcd_string As String * 20

'------------------------    I2c  ----------------------------------

  Config Sda = Portc.4       '  
  Config Scl = Portc.5       '  
  Config I2cdelay = 5       '  i2c "10 - 100, 5 - 200, 2 - 500, 1 - 1" -         
  I2cinit '  i2c
  Dim _i2c As Byte

'------------------------------------------------------------------
'|             |  PCF8574,PCF8574N, PCF8575 |  PCF8574A, PCF8574AP |
'|-------------|----------------------------|----------------------|
'|  A0  A1  A2 |       |        |     |    |
'|-------------|-------------|--------------|-----------|----------|
'|  0   0   0  |      &H40   |     &H41     |    &H70   |   &H71   |
'|  1   0   0  |      &H42   |     &H43     |    &H72   |   &H73   |
'|  0   1   0  |      &H44   |     &H45     |    &H74   |   &H75   |
'|  1   1   0  |      &H46   |     &H47     |    &H76   |   &H77   |
'|  0   0   1  |      &H48   |     &H49     |    &H78   |   &H79   |
'|  1   0   1  |      &H4A   |     &H4B     |    &H7A   |   &H7B   |
'|  0   1   1  |      &H4C   |     &H4D     |    &H7C   |   &H7D   |
'|  1   1   1  |      &H4E   |     &H4F     |    &H7E   |   &H7F   |
'------------------------------------------------------------------

'-------------------------        ---------------------------------

  Const __pcf8575 = &H42
  Const __pcf8575 = &H43

'-----------------------        ------------------------------

  Const __pcf8575 = &H40
  Const __pcf8575 = &H41

'-----------------------         --------------------------

  Const ___pcf8575 = &H4E
  Const ___pcf8575 = &H4F

'-------------------------      PCF8574   -----------------------------

  Dim _ As Word       '      
  _ = 0

'-------------------------------------------------------------------------------------------
'!!!   PCF8575    2 , -    !
'-------------------------------------------------------------------------------------------
  I2csend __pcf8575 , _ , 2       '   PCF8575    2 , -    !

'--------------      PCF8575  ----------------

  Config Pind.3 = Input       '    
  Set Portd.3
  Config Int1 = Falling       '        Rising ; Falling ; Low Level
  On Int1 _       'Nosave       '>           PCF8575
  Const  = 0       '   (   ""

'------------------         -------------------

  Config Portc.0 = Output       '    
   Alias Portc.0       '      

'--------------------         ----------------------

  Config Portb.7 = Output       '    
   Alias Portb.7       '      
  Dim _ As Byte
  _ = 30

'------------------------     ------------------------------

  Defbit _ As Bit       '       
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  Dim __ As Word       '       
'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  Dim __ As Byte       '      ,       
  Dim __ As Byte       '        
  Dim ___ As Byte       '      LCD
  Dim __ As Byte       '       ,       
  Dim __word As Word
  __word = 1

'------------------------      -----------------------

  Enable Int1

'-----------------       -----------------

  Enable Interrupts       '   

'=================================================
  Do : Nop
'---------------

    If __ = 1 Then Rcall _

    If ___ = 1 And __ = 1 Then Rcall __lcd

    rcall _

    Waitms 100

'------------
  Loop
 End
'=================================================

'                                         

'=================================================



'*******************************************************************************
'*************        PCF8575   *************
'*******************************************************************************
'-------------------------------------------------------------------------------
  ___:
'-------------------------------------------------------------------------------
    I2creceive __pcf8575 , __ , 0 , 2       '     PCF8575 key

    If __ > 0 And __ < 65535 Then __ = 1
'-------------------------------------------------------------------------------
  Return
'-------------------------------------------------------------------------------
'*******************************************************************************
'-------------------------------------------------------------------------------
'*******************************************************************************
'***************       PCF8575   **************
'*******************************************************************************
'-------------------------------------------------------------------------------
  __:
'-------------------------------------------------------------------------------
    I2creceive __pcf8575 , _ , 0 , 2       '      PCF8575 
'-------------------------------------------------------------------------------
  Return
'-------------------------------------------------------------------------------
'*******************************************************************************
'-------------------------------------------------------------------------------
'*******************************************************************************
'**************       PCF8575   ***************
'*******************************************************************************
'-------------------------------------------------------------------------------
  __:
'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------
'!!!   PCF8574    2 , -    !
'-------------------------------------------------------------------------------
    I2csend __pcf8575 , _ , 2       '   PCF8574    2 , -    !
'-------------------------------------------------------------------------------
  Return
'-------------------------------------------------------------------------------
'*******************************************************************************
'-------------------------------------------------------------------------------
'*******************************************************************************
'**************       PCF8575   ***************
'*******************************************************************************
'-------------------------------------------------------------------------------
  _:
'-------------------------------------------------------------------------------
   If __ = 1 Then

       Waitms 

       rCall ___

       Incr __

       If __ > 2 And __ = 65535 Then __ = 0

     Else

       __ = 0

      Goto __

   End If
'------------------------------------------------
   rCall __
'------------------------------------------------
      Select Case __
     '------------------------------------------------
       Case Is = 0 : Goto __
     '------------------------------------------------
       Case Is = 65535 : Goto __
     '------------------------------------------------
       Case Is = 65534 :
     '------------------------------------------------
                       If __ = 1 Then

                           __0 = _.0       '   
                           Toggle __0       ' , ,  
                           _.0 = __0       ' , ,  ,   

                           rCall Bip_bip       ' 
                         Else
                       End If
     '------------------------------------------------
       Case Is = 65533 :
     '------------------------------------------------
                       If __ = 1 Then

                           __1 = _.1
                           Toggle __1
                           _.1 = __1

                           rCall Bip_bip
                         Else
                       End If
     '------------------------------------------------
       Case Is = 65531 :
     '------------------------------------------------
                       If __ = 1 Then

                           __2 = _.2
                           Toggle __2
                           _.2 = __2

                           rCall Bip_bip
                         Else
                       End If
     '------------------------------------------------
       Case Is = 65527 :
     '------------------------------------------------
                       If __ = 1 Then

                           __3 = _.3
                           Toggle __3
                           _.3 = __3

                           rCall Bip_bip
                         Else
                       End If
     '------------------------------------------------
       Case Is = 65519 :
     '------------------------------------------------
                       If __ = 1 Then

                           __4 = _.4
                           Toggle __4
                           _.4 = __4

                           rCall Bip_bip
                         Else
                       End If
     '------------------------------------------------
       Case Is = 65503 :
     '------------------------------------------------
                       If __ = 1 Then

                           __5 = _.5
                           Toggle __5
                           _.5 = __5

                           rCall Bip_bip
                         Else
                       End If
     '------------------------------------------------
       Case Is = 65471 :
     '------------------------------------------------
                       If __ = 1 Then

                           __6 = _.6
                           Toggle __6
                           _.6 = __6

                           rCall Bip_bip
                         Else
                       End If
     '------------------------------------------------
       Case Is = 65407 :
     '------------------------------------------------
                       If __ = 1 Then

                           __7 = _.7
                           Toggle __7
                           _.7 = __7

                           rCall Bip_bip
                         Else
                       End If
     '------------------------------------------------
       Case Is = 65279 :
     '------------------------------------------------
                       If __ = 1 Then

                           __8 = _.8
                           Toggle __8
                           _.8 = __8

                           rCall Bip_bip
                         Else
                       End If
     '------------------------------------------------
       Case Is = 65023 :
     '------------------------------------------------
                       If __ = 1 Then

                           __9 = _.9
                           Toggle __9
                           _.9 = __9

                           rCall Bip_bip
                         Else
                       End If
     '------------------------------------------------
       Case Is = 64511 :
     '------------------------------------------------
                       If __ = 1 Then

                           __10 = _.10
                           Toggle __10
                           _.10 = __10

                           rCall Bip_bip
                         Else
                       End If
     '------------------------------------------------
       Case Is = 63487 :
     '------------------------------------------------
                       If __ = 1 Then

                           __11 = _.11
                           Toggle __11
                           _.11 = __11

                           rCall Bip_bip
                         Else
                       End If
     '------------------------------------------------
       Case Is = 61439 :
     '------------------------------------------------
                       If __ = 1 Then

                           __12 = _.12
                           Toggle __12
                           _.12 = __12

                           rCall Bip_bip
                         Else
                       End If
     '------------------------------------------------
       Case Is = 57343 :
     '------------------------------------------------
                       If __ = 1 Then

                           __13 = _.13
                           Toggle __13
                           _.13 = __13

                           rCall Bip_bip
                         Else
                       End If
     '------------------------------------------------
       Case Is = 49151 :
     '------------------------------------------------
                       If __ = 1 Then

                           __14 = _.14
                           Toggle __14
                           _.14 = __14

                           rCall Bip_bip
                         Else
                       End If
     '------------------------------------------------
       Case Is = 32767 :
     '------------------------------------------------
                       If __ = 1 Then

                           __15 = _.15
                           Toggle __15
                           _.15 = __15

                           rCall Bip_bip
                         Else
                       End If
     '------------------------------------------------
       End Select
     '------------------------------------------------

       rcall __

       __ = 0
'------------------------------------------------
     __:

     ___ = 1

'------------------------------------------------
    Gifr = 64
  Return
'-------------------------------------------------------------------------------
'*******************************************************************************
'-------------------------------------------------------------------------------
'*******************************************************************************
'-------------------------------------------------------------------------------
  Bip_bip:
'-------------------------------------------------------------------------------
    Set 

    Waitms _

    Reset 
'-------------------------------------------------------------------------------
  Return
'-------------------------------------------------------------------------------
'*******************************************************************************
'-------------------------------------------------------------------------------
'*******************************************************************************
'******************        *********************
'*******************************************************************************
'-------------------------------------------------------------------------------
  _:
'-------------------------------------------------------------------------------
    __ = 1

    __ = 1

'    Gifr = 64
'-------------------------------------------------------------------------------
  Return
'-------------------------------------------------------------------------------
'*******************************************************************************
'-------------------------------------------------------------------------------
'*******************************************************************************
'***********************     LCD  **************************
'*******************************************************************************
'-------------------------------------------------------------------------------
  __lcd:
'-------------------------------------------------------------------------------
    _lcd_string = Str(__)

    _lcd_string = Format(_lcd_string , "  0")

    Locate 1 , 1
    Lcd "Ko o " ; _lcd_string       ' "  "
    Print "  " ; _lcd_string
    Locate 2 , 1
    Lcd "Ko o " ; Hex(__)       ' "  "
    Print "  " ;  Hex(__)
    Locate 3 , 1
    Lcd "Ko o " ; Bin(__)       ' "  "
    Print "  " ; Bin(__)
    Locate 4 , 1
    Lcd "Out " ; Bin(_)       ' " "
    Print " " ; Bin(_)       ' " "
    Print ""
    Print ""

    ___ = 0

'-------------------------------------------------------------------------------
  Return
'-------------------------------------------------------------------------------
'*******************************************************************************
'-------------------------------------------------------------------------------
'*******************************************************************************
'**********************        *************************
'*******************************************************************************
'-------------------------------------------------------------------------------
  _:
'-------------------------------------------------------------------------------

    Rotate __word , Left       '    

    I2csend ___pcf8575 , __word , 2       '   PCF8575

'-------------------------------------------------------------------------------
  Return
'-------------------------------------------------------------------------------
'*******************************************************************************
'-------------------------------------------------------------------------------